#property strict

#include "Buffer.mqh"

class INDICATOR : public EVENTBASE
{
private:
template <typename T>
  static void DeleteArrayPointers( T &ArrayPointers[] )
  {
    const int Amount = ::ArraySize(ArrayPointers);

    for (int i = 0; i < Amount; i++)
      if (::CheckPointer(ArrayPointers[i]) == POINTER_DYNAMIC)
        delete(ArrayPointers[i]);

    return;
  }

protected:
  BUFFER* Buffers[];

  void SetEmpty( void )
  {
    const int Amount = this.GetAmountBuffers();

    for (int i = 0; i < Amount; i++)
      this.Buffers[i].SetEmptyValue();

    return;
}

public:
  INDICATOR( const bool AddEvent = FALSE ) : EVENTBASE(AddEvent)
  {
  }

  ~INDICATOR( void )
  {
    this.DeleteArrayPointers(this.Buffers);
  }

  virtual BUFFER* operator []( const int Pos ) const
  {
    return(this.Buffers[Pos]);
  }

  virtual int GetAmountBuffers( void ) const
  {
    return(::ArraySize(this.Buffers));
  }

  virtual int Calculate( const int rates_total,
                         const int prev_calculated,
                         const datetime &time[],
                         const double &open[],
                         const double &high[],
                         const double &low[],
                         const double &close[],
                         const long &tick_volume[],
                         const long &volume[],
                         const int &spread[] )
  {
    return(rates_total);
  }

  virtual void DeInit( const int reason )
  {
    return;
  }

  // AS_SERIES == TRUE
  static int CorrectIndex( int Index, const int rates_total )
  {
    if (Index >= rates_total)
      Index = rates_total - 1;

    if (Index < 0)
      Index = 0;

    return(Index);
  }

  void ToVisual( const int iTimeToVisual = 0 )
  {
    const int Amount = this.GetAmountBuffers();

    for (int i = 0; i < Amount; i++)
      this.Buffers[i].ToVisual(this, iTimeToVisual);

    return;
  }
};