#property strict

#include "Price.mqh"
//#include "Datetime.mqh"

struct QUOTE
{
  PRICE bid;
  PRICE ask;

//  DATETIME time; //   
  datetime time;

  QUOTE( void ) : time(NULL)
  {
  }

  void SetMarkUp( const int Pips )
  {
    ask += Pips;
    bid -= Pips;

    return;
  }

  void SetMarkUp( const double Shift )
  {
    const double MarkUpAsk = 1 + Shift / 100;
    const double MarkUpBid = 1 - Shift / 100;

    ask *= MarkUpAsk;
    bid *= MarkUpBid;

    return;
  }

  const bool operator >( const int Value ) const
  {
    return(this.bid > Value);
  }

  const bool operator >=( const int Value ) const
  {
    return(this.bid >= Value);
  }

  const bool operator <=( const int Value ) const
  {
    return(this.ask <= Value);
  }

  const bool operator >( const QUOTE &Quote ) const
  {
    return(this.bid > Quote.bid);
  }

  const bool operator <( const QUOTE &Quote ) const
  {
    return(this.ask < Quote.ask);
  }

  const QUOTE operator -( const QUOTE &Price ) const
  {
    QUOTE Res;

    Res.bid = this.bid - Price.ask;
    Res.ask = this.ask - Price.bid;

    return(Res);
  }

  const QUOTE operator -( void ) const
  {
    QUOTE Res;

    Res.bid = this.ask;
    Res.ask = this.bid;

    return(Res);
  }

  string ToString( void ) const
  {
//    return(this.time.ToString() + " bid(" + this.bid.ToString() + "), ask(" + this.ask.ToString() + ")");
    return((string)this.time + " bid(" + this.bid.ToString() + "), ask(" + this.ask.ToString() + ")");
  }
};